/* eslint-disable-next-line no-unused-vars */ // This class is used in other files
class ThreadGroup {
  constructor(parent, children = []) {
    this.parent = parent;
    this.children = children;
    this.collapsed = false;
  }

  makeCollapsable() {
    const button = document.getElementById(this.parent.htmlId + "collapse_button");
    button.onclick = this.toggleCollapse.bind(this);
    button.innerHTML = "◢";
  }

  toggleCollapse() {
    // collapsed groups hide all children and only show the statusbar of the parent
    const childrenIdList = [];
    Object.keys(this.children).forEach((key) => {
      childrenIdList.push(this.children[key].htmlId);
    });
    const button = document.getElementById(this.parent.htmlId + "collapse_button");
    if (this.collapsed === true) {
      Object.keys(childrenIdList).forEach((key) => {
        document.getElementById(childrenIdList[key]).classList.remove("collapsed");
      });
      document.getElementById(this.parent.htmlId + "content").classList.remove("collapsed");
      button.innerHTML = "◢";
    } else {
      button.innerHTML = "▶";
      Object.keys(childrenIdList).forEach((key) => {
        document.getElementById(childrenIdList[key]).classList.add("collapsed");
      });
      document.getElementById(this.parent.htmlId + "content").classList.add("collapsed");
    }
    this.collapsed = !this.collapsed;
  }

  getGroupHtml() {
    const parentHtml = this.parent.getHtml();

    let childrenHtml = "";
    Object.keys(this.children).forEach((childKey) => {
      childrenHtml += this.children[childKey].getHtml();
    });

    return "<p>" + parentHtml + childrenHtml + "</p>";
  }
}
